diff --git a/render/gles2/renderer.c b/render/gles2/renderer.c
index 523c5bd547..cba338a167 100644
--- a/render/gles2/renderer.c
+++ b/render/gles2/renderer.c
@@ -10,6 +10,7 @@
 #include <wlr/render/interface.h>
 #include <wlr/render/wlr_renderer.h>
 #include <wlr/types/wlr_matrix.h>
+#include <wlr/types/wlr_linux_dmabuf_v1.h>
 #include <wlr/util/log.h>
 #include "render/gles2.h"
 
@@ -364,6 +365,15 @@ static bool gles2_init_wl_display(struct wlr_renderer *wlr_renderer,
 	} else {
 		wlr_log(WLR_INFO, "EGL_WL_bind_wayland_display is not supported");
 	}
+
+	if (renderer->egl->exts.image_dmabuf_import_ext) {
+		if (wlr_linux_dmabuf_v1_create(wl_display, wlr_renderer) == NULL) {
+			return false;
+		}
+	} else {
+		wlr_log(WLR_INFO, "EGL_EXT_image_dma_buf_import is not supported");
+	}
+
 	return true;
 }
 
diff --git a/render/wlr_renderer.c b/render/wlr_renderer.c
index b12f4b3a32..9a12670617 100644
--- a/render/wlr_renderer.c
+++ b/render/wlr_renderer.c
@@ -4,7 +4,6 @@
 #include <wlr/render/gles2.h>
 #include <wlr/render/interface.h>
 #include <wlr/render/wlr_renderer.h>
-#include <wlr/types/wlr_linux_dmabuf_v1.h>
 #include <wlr/types/wlr_matrix.h>
 #include <wlr/util/log.h>
 #include "util/signal.h"
@@ -182,12 +181,6 @@ bool wlr_renderer_init_wl_display(struct wlr_renderer *r,
 		}
 	}
 
-	if (r->impl->texture_from_dmabuf) {
-		if (wlr_linux_dmabuf_v1_create(wl_display, r) == NULL) {
-			return false;
-		}
-	}
-
 	if (r->impl->init_wl_display) {
 		if (!r->impl->init_wl_display(r, wl_display)) {
 			return false;
